#!/usr/bin/python3
# -- coding: UTF-8 --

import dbus
from pydbus import SystemBus
import syslog
import gi
gi.require_version('Gtk', '3.0')
from gi.repository import GLib, Gtk, Gio


class CDService(object):
    """
        <node>
            <interface name='com.kylin.CDControl'>
                <method name='GetStatus'>
                <arg type='i' name='status' direction='out'/>
                </method>
                <method name='SetStatus'>
                <arg type='i' name='status' direction='in'/>
                <arg type='i' name='ret' direction='out'/>
                </method>
            </interface>
        </node>
    """

    def __init__(self):
        try:
            self.sdk = SystemBus().get("com.kylin.kysdk.CDControl",
                                   "/com/kylin/kysdk/CDControl")
        except Exception:
            print("get sdk dbus error")

    def GetStatus(self):
        syslog.syslog(syslog.LOG_DEBUG, "cdrom GetStatus")
        try:
            rc = self.sdk.GetStatus()
            syslog.syslog(syslog.LOG_DEBUG, "cdrom GetStatus rc:{}".format(rc))
        except Exception:
            return -1
        return rc

    def SetStatus(self,status):
        syslog.syslog(syslog.LOG_DEBUG, "cdrom SetStatus status:{}".format(status))
        try:
            rc = self.sdk.SetStatus(status)
            syslog.syslog(syslog.LOG_DEBUG, "cdrom SetStatus rc:{}".format(rc))
        except Exception:
            return -1
        return rc



if __name__ == '__main__':
    loop = GLib.MainLoop()
    bus = SystemBus()
    bus.publish("com.kylin.CDControl",CDService())
    loop.run()