#!/usr/bin/python3
# -- coding: UTF-8 --

import syslog
import dbus
from pydbus import SystemBus
import gi
gi.require_version('Gtk', '3.0')
from gi.repository import GLib, Gtk, Gio



class PhoneService(object):
    """
        <node>
            <interface name='com.kylin.PhoneControl'>
                <method name='GetStatus'>
                <arg type='i' name='status' direction='out'/>
                </method>
                <method name='SetStatus'>
                <arg type='i' name='status' direction='in'/>
                <arg type='i' name='ret' direction='out'/>
                </method>
            </interface>
        </node>
    """
    def __init__(self):
        try:
            self.sdk = SystemBus().get("com.kylin.kysdk.PhoneControl",
                                   "/com/kylin/kysdk/PhoneControl")
        except Exception:
            print("get sdk dbus error")

    def GetStatus(self):
        try:
            rc = self.sdk.GetStatus()
            syslog.syslog(syslog.LOG_DEBUG, "phone GetStatus rc:{}".format(rc))
        except Exception:
            return -1
        return rc

    def SetStatus(self,status):
        try:
            rc = self.sdk.SetStatus(status)
            syslog.syslog(syslog.LOG_DEBUG, "phone SetStatus status:{} rc:{}".format(status,rc))
        except Exception:
            return -1
        return rc



if __name__ == '__main__':
    loop = GLib.MainLoop()
    bus = SystemBus()
    bus.publish("com.kylin.PhoneControl", PhoneService())
    loop.run()